Why RuntimeException is not caught in catch block if there are multiple catch blocks?

Tags: , ,



I am able to catch RuntimeException or subclass of it with below code:

try {
    //code that throws subclass of RuntimeException
    throw new ChildRuntimeException("try");
} catch (Exception ex) {
    System.out.println(ex.getMessage());
}

But I am getting error with below code and not able to catch RuntimeException in Exception catch block.

try {
    // code that throws subclass of Exception
    throw new ChildExceptionClass("try");
} catch (ChildExceptionClass ex) {
    throw new RuntimeException(ex.getMessage());
} catch (Exception ex) {
    System.out.println(ex.getMessage());
}

I searched for the same type of questions but did not find a suitable answer. Can anyone explain why the behaviour is different?

Answer

In the second example you are throwing a childRuntimeException, which is caught, but then a new runtimeException is thrown. This block has no “catch” clause, so the exception is thrown and not caught.

The second catch is relevant for the “try” block, not for the “catch” block.



Source: stackoverflow